PROGRAM Fuenferspiel;
  {ermittelt alle Nachfolger einer gegebenen Position}

  USES
    Crt;

  CONST
    zeilenzahl  =  2;
    spaltenzahl =  3;
    leer        = '#'; {symbolisiert leeres Feld}

  TYPE
    tFeld      = RECORD
                   zeile  : 0..zeilenzahl;
                   spalte : 0..spaltenzahl
                 END;
    tBrett     = ARRAY[1..zeilenzahl, 1..spaltenzahl] OF char;
    tPosition  = RECORD
                   brett         : tBrett;
                   leerZ, leerZ0 : tFeld;
                 END;
    tZug       = (west, nord, ost, sued);

  VAR
    anfangsposition, nachfolger : tPosition;
    zug                         : tZug;
    zeile, spalte               : integer;

  PROCEDURE Startangaben (VAR start: tPosition);
    {liest Startposition ein und prft Eingabe}
    TYPE
      tMenge = SET OF char;
    CONST
      zeichenmenge = ['1'..'5', leer];
    VAR
      korrekt : boolean;

    PROCEDURE Eingabe (VAR pos: tPosition; text: string);
      {liest Spielposition ein}
      VAR
        i, j    : integer;
        zeichen : char;
      BEGIN
        writeln('Geben Sie die ', text, ' ein!');
        WITH pos DO BEGIN
          FOR i := 1 TO zeilenzahl DO BEGIN
            writeln;
            FOR j := 1 TO spaltenzahl DO BEGIN
              write(i, '. Zeile und ', j, '. Spalte: ');
              REPEAT zeichen := readKey UNTIL zeichen IN zeichenmenge;
              writeln(zeichen); brett[i,j] := zeichen;
              IF zeichen = leer THEN BEGIN
                leerZ.zeile  := i; leerZ.spalte  := j
              END {of then}
            END {of for}
          END; {of for}
          leerZ0.zeile := 0; leerZ0.spalte := 0
        END {of with}
      END; {of Eingabe}

    FUNCTION inOrdnung (pos: tPosition): boolean;
      {prft, ob Position in Ordnung ist}
      VAR
        i, j          : integer;
        kontrollmenge : tMenge;
      BEGIN
        kontrollmenge := [];
        FOR i := 1 TO zeilenzahl DO
          FOR j := 1 TO spaltenzahl DO
            kontrollmenge := kontrollmenge + [pos.brett[i,j]];
        inOrdnung := kontrollmenge = zeichenmenge
      END; {of in Ordnung}

    BEGIN {Startangaben}
      clrScr;
      REPEAT
        Eingabe(start, 'Anfangsposition');
        korrekt := inOrdnung(start);
        IF NOT korrekt THEN BEGIN
          writeln; writeln('Eingabe fehlerhaft!')
        END
      UNTIL korrekt
    END; {of Startangaben}

  PROCEDURE Ausgabe (pos: tPosition; x, y: integer);
    {gibt einzelne Spielposition in Spalte x, Zeile y aus}
    VAR
      i, j : integer;
    BEGIN
      WITH pos DO
        FOR i := 1 TO zeilenzahl DO
          FOR j := 1 TO spaltenzahl DO BEGIN
            gotoXY(x + 2*(j-1), y + i-1); write(brett[i,j])
          END {of for}
    END; {of Ausgabe}

  FUNCTION zulaessig (zug: tZug; pos: tPosition): boolean;
    {prft Zug auf Zulssigkeit}
    BEGIN
      WITH pos DO
        CASE zug OF
          west : zulaessig := (leerZ.spalte > 1) AND
                              (leerZ.spalte - 1 <> leerZ0.spalte);
          nord : zulaessig := (leerZ.zeile  > 1) AND
                              (leerZ.zeile - 1 <> leerZ0.zeile);
          ost  : zulaessig := (leerZ.spalte < spaltenzahl) AND
                              (leerZ.spalte + 1 <> leerZ0.spalte);
          sued : zulaessig := (leerZ.zeile  < zeilenzahl) AND
                              (leerZ.zeile + 1 <> leerZ0.zeile)
        END {of case}
    END; {of zulssig}

  PROCEDURE erzeuge (VAR neu: tPosition; zug: tZug; alt: tPosition);
    {erzeugt aus alter Position und Zug eine neue Position}
    BEGIN
      neu := alt; neu.leerZ0 := neu.leerZ;
      CASE zug OF
        west : dec(neu.leerZ.spalte);
        nord : dec(neu.leerZ.zeile);
        ost  : inc(neu.leerZ.spalte);
        sued : inc(neu.leerZ.zeile)
      END; {of case}
      neu.brett[neu.leerZ.zeile, neu.leerZ.spalte] := leer;
      neu.brett[alt.leerZ.zeile, alt.leerZ.spalte] :=
                            alt.brett[neu.leerZ.zeile, neu.leerZ.spalte]
    END; {of erzeuge}

  BEGIN {Hauptprogramm}
    Startangaben(anfangsposition);

    clrScr; Ausgabe(anfangsposition, 9, 5);
    writeln; writeln; writeln('Nachfolger:'); writeln;
    spalte := whereX; zeile := whereY;

    FOR zug := west TO sued DO
      IF zulaessig(zug, anfangsposition) THEN BEGIN
        erzeuge(nachfolger, zug, anfangsposition);
        Ausgabe(nachfolger, spalte, zeile);
        inc(spalte, 8)
      END; {of then}
    readln
  END.
