PROGRAM Fuenferspiel;
  {findet Lsung mittels Tiefensuche}

  USES
    Crt;

  CONST
    zeilenzahl  =  2;
    spaltenzahl =  3;
    leer        = '#'; {symbolisiert leeres Feld}

  TYPE
    tFeld      = RECORD
                   zeile  : 0..zeilenzahl;
                   spalte : 0..spaltenzahl
                 END;
    tBrett     = ARRAY[1..zeilenzahl, 1..spaltenzahl] OF char;
    tPosition  = RECORD
                   brett         : tBrett;
                   leerZ, leerZ0 : tFeld
                 END;
    tZeiger    = ^tKnoten;
    tKnoten    = RECORD
                   inhalt                  : tPosition;
                   zNaechster, zVorgaenger : tZeiger;
                   rang                    : integer
                 END;

  VAR
    zAnfang, zEnde : tZeiger;
    tiefenschranke : integer;
    gefunden       : boolean;

  PROCEDURE generiere (VAR zKnoten: tZeiger; pos: tPosition; r: integer);
    {erzeugt dynamische Variable und gibt Zeiger darauf zurck}
    BEGIN
      new(zKnoten);
      zKnoten^.inhalt := pos;
      zKnoten^.zVorgaenger := NIL;
      zKnoten^.rang := r
    END; {of generiere}

  PROCEDURE Startangaben (VAR zStartknoten, zEndknoten: tZeiger);
    {liest Start- und Zielposition ein und prft Eingabe}
    TYPE
      tMenge = SET OF char;
    CONST
      zeichenmenge = ['1'..'5', leer];
    VAR
      start, ziel : tPosition;
      korrekt     : boolean;

    PROCEDURE Eingabe (VAR pos: tPosition; text: string);
      {liest Spielposition ein}
      VAR
        i, j    : integer;
        zeichen : char;
      BEGIN
        writeln('Geben Sie die ', text, ' ein!');
        WITH pos DO BEGIN
          FOR i := 1 TO zeilenzahl DO BEGIN
            writeln;
            FOR j := 1 TO spaltenzahl DO BEGIN
              write(i, '. Zeile und ', j, '. Spalte: ');
              REPEAT zeichen := readKey UNTIL zeichen IN zeichenmenge;
              writeln(zeichen); brett[i,j] := zeichen;
              IF zeichen = leer THEN BEGIN
                leerZ.zeile  := i; leerZ.spalte  := j
              END {of then}
            END {of for}
          END; {of for}
          leerZ0.zeile := 0; leerZ0.spalte := 0
        END {of with}
      END; {of Eingabe}

    FUNCTION inOrdnung (pos: tPosition): boolean;
      {prft, ob Position in Ordnung ist}
      VAR
        i, j          : integer;
        kontrollmenge : tMenge;
      BEGIN
        kontrollmenge := [];
        FOR i := 1 TO zeilenzahl DO
          FOR j := 1 TO spaltenzahl DO
            kontrollmenge := kontrollmenge + [pos.brett[i,j]];
        inOrdnung := kontrollmenge = zeichenmenge
      END; {of in Ordnung}

    BEGIN {Startangaben}
      clrScr;
      REPEAT
        Eingabe(start, 'Anfangsposition');
        korrekt := inOrdnung(start);
        IF NOT korrekt THEN BEGIN
          writeln; writeln('Eingabe fehlerhaft!')
        END
      UNTIL korrekt;
      generiere(zStartknoten, start, 1);
      writeln;
      REPEAT
        Eingabe(ziel, 'Endposition');
        korrekt := inOrdnung(ziel);
        IF NOT korrekt THEN BEGIN
          writeln; writeln('Eingabe fehlerhaft!')
        END
      UNTIL korrekt;
      generiere(zEndknoten, ziel, 1);
      writeln; write('Tiefenschranke? ');
      readln(tiefenschranke);
    END; {of Startangaben}

  PROCEDURE Ausgabe (pos: tPosition; x, y: integer);
    {gibt einzelne Spielposition in Spalte x, Zeile y aus}
    VAR
      i, j : integer;
    BEGIN
      WITH pos DO
        FOR i := 1 TO zeilenzahl DO
          FOR j := 1 TO spaltenzahl DO BEGIN
            gotoXY(x + 2*(j-1), y + i-1); write(brett[i,j])
          END {of for}
    END; {of Ausgabe}

  PROCEDURE Zugfolge (zS: tZeiger; VAR zE: tZeiger; VAR erfolg: boolean);
    {die Folge der Spielzge}
    TYPE
      tZug = (west, nord, ost, sued);
    VAR
      zAnwaerterliste, zBesuchtliste,
      zEntwicklungsknoten, zNachfolger : tZeiger;
      zug                              : tZug;
      nachfolger                       : tPosition;
      tiefe                            : integer;

    FUNCTION gleich (pos1, pos2: tPosition): boolean;
      {prft, ob zwei Positionen gleich sind}
      VAR
        i, j : integer;
      BEGIN
        gleich := false;
        FOR i := 1 TO zeilenzahl DO
          FOR j := 1 TO spaltenzahl DO
            IF pos1.brett[i,j] <> pos2.brett[i,j] THEN exit;
        gleich := true
      END; {of gleich}

    PROCEDURE fuege_vorne_an (zKnoten: tZeiger; VAR zKopf: tZeiger);
      {fgt Knoten vorne an und gibt Zeiger auf Listenkopf zurck}
      BEGIN
        zKnoten^.zNaechster := zKopf;
        zKopf := zKnoten
      END; {of fge an}

    PROCEDURE hole_vorne_von (VAR zKnoten, zKopf: tZeiger);
      {entfernt Listenkopf und gibt Zeiger auf neuen Kopf zurck}
      BEGIN
        IF zKopf <> NIL THEN BEGIN
          zKnoten := zKopf;
          zKopf := zKnoten^.zNaechster
        END; {of then}
      END; {of hole vorne von}

    FUNCTION vorhanden (pos: tPosition; zAktuell: tZeiger): boolean;
      {prft rekursiv, ob Position in der Liste vorkommt}
      BEGIN
        IF zAktuell = NIL THEN
          vorhanden := false
        ELSE IF gleich(zAktuell^.inhalt, pos) THEN
          vorhanden := true
        ELSE
          vorhanden := vorhanden(pos, zAktuell^.zNaechster)
      END; {of vorhanden}

    PROCEDURE zeige (zKopf: tZeiger; text: string; x, y: integer);
      {zeigt Besucht- oder Anwrterliste}
      VAR
        zAktuell              : tZeiger;
        zeile, spalte, anzahl : integer;
      BEGIN
        zeile := y; spalte := x;
        gotoXY(spalte, zeile); write(text, ':'); inc(zeile);
        zAktuell := zKopf; anzahl := 0;
        WHILE zAktuell <> NIL DO BEGIN
          Ausgabe(zAktuell^.inhalt, spalte, zeile);
          zAktuell := zAktuell^.zNaechster;
          inc(spalte, 8); inc(anzahl);
          IF anzahl MOD 10 = 0 THEN BEGIN
            inc(zeile, 3); spalte := 1
          END
        END {of while}
      END; {of zeige}

    FUNCTION zulaessig (zug: tZug; pos: tPosition): boolean;
      {prft Zug auf Zulssigkeit}
      BEGIN
        WITH pos DO
          CASE zug OF
            west : zulaessig := (leerZ.spalte > 1) AND
                                (leerZ.spalte - 1 <> leerZ0.spalte);
            nord : zulaessig := (leerZ.zeile  > 1) AND
                                (leerZ.zeile - 1 <> leerZ0.zeile);
            ost  : zulaessig := (leerZ.spalte < spaltenzahl) AND
                                (leerZ.spalte + 1 <> leerZ0.spalte);
            sued : zulaessig := (leerZ.zeile  < zeilenzahl) AND
                                (leerZ.zeile + 1 <> leerZ0.zeile)
          END {of case}
      END; {of zulssig}

    PROCEDURE erzeuge (VAR neu: tPosition; zug: tZug; alt: tPosition);
      {erzeugt aus alter Position und Zug eine neue Position}
      BEGIN
        neu := alt; neu.leerZ0 := neu.leerZ;
        CASE zug OF
          west : dec(neu.leerZ.spalte);
          nord : dec(neu.leerZ.zeile);
          ost  : inc(neu.leerZ.spalte);
          sued : inc(neu.leerZ.zeile)
        END; {of case}
        neu.brett[neu.leerZ.zeile, neu.leerZ.spalte] := leer;
        neu.brett[alt.leerZ.zeile, alt.leerZ.spalte] :=
                              alt.brett[neu.leerZ.zeile, neu.leerZ.spalte]
      END; {of erzeuge}

    BEGIN {Zugfolge}
      clrScr; erfolg := false;
      zBesuchtliste := NIL; zAnwaerterliste := NIL;
      fuege_vorne_an(zS, zAnwaerterliste);
      REPEAT
        hole_vorne_von(zEntwicklungsknoten, zAnwaerterliste);
        IF gleich(zEntwicklungsknoten^.inhalt, zE^.inhalt) THEN BEGIN
          erfolg := true; zE := zEntwicklungsknoten
        END ELSE BEGIN
          tiefe := zEntwicklungsknoten^.rang;

          clrScr; Ausgabe(zEntwicklungsknoten^.inhalt, 30, 1);
          gotoXY(28, 4); write('Tiefe: ', tiefe);
          zeige(zAnwaerterliste, 'Anwrterliste', 1, 6);
          zeige(zBesuchtliste, 'Besuchtliste', 1, 11);
          readln;

          IF tiefe < tiefenschranke THEN BEGIN
            fuege_vorne_an(zEntwicklungsknoten, zBesuchtliste);
            FOR zug := sued DOWNTO west DO
              IF zulaessig(zug, zEntwicklungsknoten^.inhalt) THEN BEGIN
                erzeuge(nachfolger, zug, zEntwicklungsknoten^.inhalt);
                IF NOT vorhanden(nachfolger, zAnwaerterliste) AND
                   NOT vorhanden(nachfolger, zBesuchtliste) THEN BEGIN
                  generiere(zNachfolger, nachfolger, tiefe + 1);
                  fuege_vorne_an(zNachfolger, zAnwaerterliste);
                  zAnwaerterliste^.zVorgaenger := zEntwicklungsknoten
                END {of then}
              END {of then}
          END {of then}
        END {of else}
      UNTIL erfolg OR (zAnwaerterliste = NIL)
    END; {of Zugfolge}

  PROCEDURE Endinformation (zEndknoten: tZeiger; erfolg: boolean);
    {gibt Lsungspfad, sofern existent, aus}

    PROCEDURE zeige_Weg (zKopf: tZeiger);
      {zeigt Weg durch den Suchbaum}
      VAR
        zAktuell              : tZeiger;
        zeile, spalte, anzahl : integer;
      BEGIN
        zAktuell := zKopf; anzahl := 0;
        zeile := whereY + 1; spalte := whereX;
        WHILE zAktuell <> NIL DO BEGIN
          Ausgabe(zAktuell^.inhalt, spalte, zeile);
          zAktuell := zAktuell^.zVorgaenger;
          inc(spalte, 8); inc(anzahl);
          IF anzahl MOD 10 = 0 THEN BEGIN
            inc(zeile, 3); spalte := 1
          END
        END {of while}
      END; {of zeige Weg}

    BEGIN {Endinformation}
      writeln; writeln;
      IF NOT erfolg THEN
        writeln('Keine Lsung gefunden.')
      ELSE BEGIN
        writeln('Lsungspfad (rckwrts):');
        zeige_Weg(zEndknoten)
      END; {of else}
      readln
    END; {of Endinformation}

  FUNCTION Schluss: boolean;
    VAR
      antwort : char;
    BEGIN
      writeln; write('Noch einmal ?(j/n) ');
      REPEAT antwort := readKey UNTIL antwort IN ['j','n'];
      Schluss := antwort = 'n'
    END; {of Schlu}

  BEGIN {Hauptprogramm}
    REPEAT
      Startangaben(zAnfang, zEnde);
      Zugfolge(zAnfang, zEnde, gefunden);
      Endinformation(zEnde, gefunden)
    UNTIL Schluss
  END.
